#####
##### Simple make file
##### Useful for one source file
#####
##### THIS MAKEFILE IS FOR POLYMAKE 


.PROLOG:
        %if %exists(make.sem)
        @>
        @echo Somebody else is currently building $*
        @echo Try again later ...
        %exit 1
        %endif


.EPILOG:
        @>
        @echo Make session completed -
        @systime
        @>


.INIT:
        @systime > make.sem
        @castoff all

        # map a drive to your NLM SDK path

        @map p:=\nlmsdk    
        %setenv wcg386=$(BIN)\386wcgl.exe

        # set to your NLM SDK include dir

        %setenv INC386=p:\nlmsdk\include 


.DEINIT:
        @del make.sem
        @caston all

TARG=$[r, $(FIRSTTARGET)]

BIN=w:\public\wcc90\bin
BINB=w:\public\wcc90\binb
LIB=p:\nlmsdk\import
INCLUDE=p:\nlmsdk\include
IMP=$(LIB)\CLIB.imp
EXP=$(TARG).exp 
OBJS=$(TARG).obj $(LIB)\prelude.obj
CCOPTS=/s /ez /od /3s /zq /d1 /d_NETWARE_311_
CCCMD=wcc386p
LINKCMD=nlmlinkp
MODS=CLIB
VER=1,0,0


.c.obj:
        @>
        @echo Compiling $<
        @>
        $(CCCMD) $(CCOPTS) $<
	wdisasm /l /s=$< $(TARG).obj

.obj.nlm:
        .LIS_FILE q:\users\miked\engine\engine.def

        @>
        @echo Linking $<
        @>
        nlmlinkr < <

COPYRIGHT    "Copyright 1992, 93 Michael Day"
DEBUG
DESCRIPTION "Dist. Record Mgr. Demo"
IMPORT @$(IMP)
#EXPORT @$(EXP)
INPUT $(OBJS)
MAP
MODULE $(MODS)
OUTPUT $(TARG)
SCREENNAME "Engine Record Manager"
STACK 4096
TYPE 0
THREADNAME "Engine"
VERSION $(VER)
<
