#include <nwdsapi.h>

// new functions in NWDSMISC.H:

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSCloseIteration)
   (NWDSContextHandle, int32, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetSyntaxID)
   (NWDSContextHandle, char NWFAR *, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSReadSyntaxes)
   (NWDSContextHandle, uint32, uint8, Buf_T NWFAR *, int32 NWFAR *,
   Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSReplaceAttrNameAbbrev)
   (NWDSContextHandle, char NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetObjectHostServerAddress)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, Buf_T NWFAR *);

// new functions in NWDSASA.H:

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSAuthenticate)
   (int, uint32, NWDS_Session_Key_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSChangeObjectPassword)
   (NWDSContextHandle, uint32, char NWFAR *, char NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGenerateObjectKeyPair)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSLogin)
   (NWDSContextHandle, uint32, char NWFAR *, char NWFAR *, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSLogout)
   (NWDSContextHandle);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSVerifyObjectPassword)
   (NWDSContextHandle, uint32, char NWFAR *, char NWFAR *);

// new functions in NWDSBUFT.H:

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSAllocBuf)
   (size_t, Buf_T NWFAR * NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSComputeAttrValSize)
   (NWDSContextHandle, Buf_T NWFAR *, uint32, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSFreeBuf)
   (Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetAttrCount)
   (NWDSContextHandle, Buf_T NWFAR *, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetAttrDef)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *, Attr_Info_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetAttrName)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *, uint32 NWFAR *,
   uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetAttrVal)
   (NWDSContextHandle, Buf_T NWFAR *, uint32, void NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetClassDef)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *, Class_Info_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetClassDefCount)
   (NWDSContextHandle, Buf_T NWFAR *, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetClassItem)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetClassItemCount)
   (NWDSContextHandle, Buf_T NWFAR *, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetObjectCount)
   (NWDSContextHandle, Buf_T NWFAR *, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetObjectName)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *, uint32 NWFAR *,
   Object_Info_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetPartitionInfo)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetServerName)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetSyntaxCount)
   (NWDSContextHandle, Buf_T NWFAR *, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetSyntaxDef)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *, Syntax_Info_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSInitBuf)
   (NWDSContextHandle, uint32, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSPutAttrName)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSPutAttrVal)
   (NWDSContextHandle, Buf_T NWFAR *, uint32, void NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSPutChange)
   (NWDSContextHandle, Buf_T NWFAR *, uint32, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSPutClassItem)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSPutClassName)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSPutSyntaxName)
   (NWDSContextHandle, Buf_T NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSBeginClassItem)
   (NWDSContextHandle, Buf_T NWFAR *);

// new functions in NWDSPART.H:

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSAddPartition)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, int32 NWFAR *, uint8,
   Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSAddReplica)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSChangeReplicaType)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSJoinPartitions)
   (NWDSContextHandle, char NWFAR *, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSListPartitions)
   (NWDSContextHandle, int32 NWFAR *, char NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSRemovePartition)
   (NWDSContextHandle, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSRemoveReplica)
   (NWDSContextHandle, char NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSSplitPartition)
   (NWDSContextHandle, char NWFAR *, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSSyncPartition)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSSyncSchema)
   (NWDSContextHandle, char NWFAR *, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSRepairTimeStamps)
   (NWDSContextHandle, char NWFAR *, char NWFAR *);

// new functions in NWDSNAME.H:

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSAbbreviateName)
   (NWDSContextHandle, char NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSCanonicalizeName)
   (NWDSContextHandle, char NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSRemoveAllTypes)
   (NWDSContextHandle, char NWFAR *, char NWFAR *);

// new functions in NWDSSCH.H:

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSDefineAttr)
   (NWDSContextHandle, char NWFAR *, Attr_Info_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSDefineClass)
   (NWDSContextHandle, char NWFAR *, Class_Info_T NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSListContainableClasses)
   (NWDSContextHandle, char NWFAR *, int32 NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSModifyClassDef)
   (NWDSContextHandle, char NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSReadAttrDef)
   (NWDSContextHandle, uint32, uint8, Buf_T NWFAR *, int32 NWFAR *,
   Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSReadClassDef)
   (NWDSContextHandle, uint32, uint8, Buf_T NWFAR *,
   int32 NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSRemoveAttrDef)
   (NWDSContextHandle, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSRemoveClassDef)
   (NWDSContextHandle, char NWFAR *);

// new functions in NWDSDC.H:

typedef NWDSContextHandle NWFAR NWPASCAL (*T_NWDSCreateContext)
   (void);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSFreeContext)
   (NWDSContextHandle);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetContext)
   (NWDSContextHandle, int, void NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSSetContext)
   (NWDSContextHandle, int, void NWFAR *);

// new functions in NWDSACL.H:

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetEffectiveRights)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, char NWFAR *,
   uint32 NWFAR *);

// new functions in NWDSDSA.H:

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSAddObject)
   (NWDSContextHandle, char NWFAR *, int32 NWFAR *, uint8, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSBackupObject)
   (NWDSContextHandle, char NWFAR *, int32 NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSCompare)
   (NWDSContextHandle, char NWFAR *, Buf_T NWFAR *, uint8 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetPartitionRoot)
   (NWDSContextHandle, char NWFAR *, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSList)
   (NWDSContextHandle, char NWFAR *, int32 NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSMapIDToName)
   (NWDSContextHandle, int, uint32, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSMapNameToID)
   (NWDSContextHandle, int, char NWFAR *, uint32 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSModifyObject)
   (NWDSContextHandle, char NWFAR *, int32 NWFAR *, uint8, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSModifyDN)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, uint8);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSRead)
   (NWDSContextHandle, char NWFAR *, uint32, uint8, Buf_T NWFAR *,
   int32 NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSReadEffectivePrivileges)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, uint8, Buf_T NWFAR *,
   int32 NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSReadObjectInfo)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, Object_Info_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSRemoveObject)
   (NWDSContextHandle, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSRestoreObject)
   (NWDSContextHandle, char NWFAR *, int32 NWFAR *, uint8, uint32,
   uint8 NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSSearch)
   (NWDSContextHandle, char NWFAR *, int, uint8, Buf_T NWFAR *, uint32,
   uint8, Buf_T NWFAR *, int32 NWFAR *, int32,
   int32 NWFAR *, Buf_T NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSOpenStream)
   (NWDSContextHandle, char NWFAR *, char NWFAR *, uint32, int NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSWhoAmI)
   (NWDSContextHandle, char NWFAR *);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetServerDN)
   (NWDSContextHandle, int, char NWFAR *);
   
typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSGetServerAddresses)
   (NWDSContextHandle, int, uint32 NWFAR *,
   Buf_T NWFAR *);

// new functions in NWDSFILT.H:

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSAddFilterToken)
   (Filter_Cursor_T NWFAR *, uint16, void NWFAR *, uint32);

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSAllocFilter)
   (Filter_Cursor_T NWFAR * NWFAR *);

typedef void NWFAR NWPASCAL (*T_NWDSFreeFilter)
   (Filter_Cursor_T NWFAR *, void (NWFAR *)(uint32, void NWFAR *));

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSPutFilter)
   (NWDSContextHandle, Buf_T NWFAR *, Filter_Cursor_T NWFAR *,
   void (NWFAR *)(uint32, void NWFAR *));

typedef NWDSCCODE NWFAR NWPASCAL (*T_NWDSDelFilterToken)
   (Filter_Cursor_T NWFAR *, void (NWFAR *)(uint32, void NWFAR *));
